//----------------------------------------------------------------------------
//  File:   UDPExampleDlg.cpp
//
//  Desc:   Example MFC Application that shows how to use the AMISocket Class
//
//  c.2003  Alcorn McBride - Scott Harkless
//----------------------------------------------------------------------------

#include "stdafx.h"
#include "UDPExample.h"
#include "UDPExampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CUDPExampleDlg dialog
CUDPExampleDlg::CUDPExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUDPExampleDlg::IDD, pParent)
	, m_cstrResponse(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CUDPExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_RESPONSE, m_cstrResponse);
}


BEGIN_MESSAGE_MAP(CUDPExampleDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(WM_UDP_RECEIVE, OnUDPMsg)			// Message Map Entry for the UDP Receive Message
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_SEARCH, OnBnClickedSearch)
	ON_BN_CLICKED(IDC_PLAY, OnBnClickedPlay)
	ON_BN_CLICKED(IDC_STOP, OnBnClickedStop)
END_MESSAGE_MAP()


// CUDPExampleDlg message handlers

BOOL CUDPExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	
	// TODO: Add extra initialization here

	// Initialize and Open UDP Socket
	m_UDPControlSocket.InitAndOpenUDPSocket(this->m_hWnd, AMINET_PORT, TRUE);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CUDPExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUDPExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUDPExampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}






//----------------------------------------------------------------------------
// Ethernet Data Receive Event - OnUDPMsg
//----------------------------------------------------------------------------
afx_msg LRESULT CUDPExampleDlg::OnUDPMsg (WPARAM wParam, LPARAM lParam)
{
	// Point to UDP information
	UDPBuffer * IncomingUDPMessage = (UDPBuffer *) lParam;

	// Display the source IP Address of the Message
	m_cstrResponse = "Received (" + IncomingUDPMessage->Address + ")";
	
	// If this is a decoded AMINet Message, Display *AMINet* in the response
	if(IncomingUDPMessage->AMINet)
		m_cstrResponse += " *AMINet*";

	// Display the string that was received
	m_cstrResponse += ": " + (CString) IncomingUDPMessage->buf + "\r\n";

	// Send Message to Edit Box
	GetDlgItem(IDC_RESPONSE)->SetWindowText(m_cstrResponse);

	return 1;
}



/***********************
*	 Button Controls   *
***********************/

//----------------------------------------------------------------------------
// Search to Video 1 - Default DVM2 IP Address
//----------------------------------------------------------------------------
void CUDPExampleDlg::OnBnClickedSearch()
{
	m_UDPControlSocket.SendAMINetMessage("1SE", "192.168.0.254");
}


//----------------------------------------------------------------------------
// Play Video - Default DVM2 IP Address
//----------------------------------------------------------------------------
void CUDPExampleDlg::OnBnClickedPlay()
{
	m_UDPControlSocket.SendAMINetMessage("PL", "192.168.0.254");
}


//----------------------------------------------------------------------------
// Stop Video - Default DVM2 IP Address
//----------------------------------------------------------------------------
void CUDPExampleDlg::OnBnClickedStop()
{
	m_UDPControlSocket.SendAMINetMessage("RJ", "192.168.0.254");
}
